 ; ---------------------------------------------
 ;|        PUISSANCE 4 version 1.60             |
 ;|        mise  jour de la version 1.55       |
 ;|        programm par Julien WALLIOR         |
 ;|         partir du 3 dcembre 1999      	|
 ;|        sortie le 15 juin 2000               |
 ; ---------------------------------------------



 
	include     "userlib.h"
	include     "graphlib.h"
	include     "util.h"
	include     "doorsos.h"
	include     "hexlib.h"
	include     "filelib.h"
	include     "genlib.h"

	include     "ia.asm"
	include     "intro.asm"	
	include     "verif.asm"
	include     "aff.asm"
;	include     "link.asm"
	include     "langage.asm"


	xdef        _main                                                           ;nom du label initial
	xdef        _comment                                                        ;nom du commentaire
	xdef        _ti89                                                           ;programme pour la ti89
	xdef        _ti92plus
	xdef        _exit


attend      	equ        64999
attend2         equ        1

retour:
	rts

tpui:
	mulu.w      #7,D1
	add.w       D0,D1
	lsl.w       #1,D1
	lea         pui,A6
	add.w       D1,A6
	rts
tpds:
	mulu.w      #7,D1
	add.w       D0,D1
	lsl.w       #1,D1
	lea         tpoids,A6
	add.w       D1,A6
	rts

                                                                                ;changement de joueur
changejsvg:
	move.w      quisvg,qui
	jmp         changej

changej:                                                                        ;changement de joueur
	move.w      qui,A0                                                      	;dplace qui dans A0
	cmp.w       #1,A0                                                           ;compare A0  2
	beq         joueur1                                                         ;si A0=2 goto joueur2
	move.w      #0,qui                                                      	;met 0 dans qui pour dire que c'est au joueur 2 de jouer
	move.w      #%1,D4
	bsr         qui_joue_2
	move.w      #%10,D4
	bsr         qui_joue_1
	move.w      qui,quisvg
	jmp         affecranb                                                       ;goto loop

joueur1:
	move.w      #%1,D4
	bsr         qui_joue_1
	move.w      #%10,D4
	bsr         qui_joue_2
	move.w      qui,quisvg
	jmp         affecranb

qui_joue_1:
	move.w      #%1110000,D0
	move.w      #%1010001,D1
	move.w      #%10,D2
	move.w      #%10,D3
	jsr         graphlib::fill
	rts
qui_joue_2:
	move.w      #%1110000,D0
	move.w      #%110101,D1
	move.w      #%10,D2
	move.w      #%10,D3
	jsr         graphlib::fill
	rts
                                                                                ;sous programme si la touche gauche est enfonce
gauche:
	move.l      #0,A0                                                           ;vide A0
	move.w      pointeur,A0                                                     ;la variable pointeur va dans A0
	move.w      pointeur,A1
	cmp.w       #%0,A0                                                      	;vrifie si A0=0
	beq         getkey                                                      	;goto loop
	sub.w       #%1,A0                                                      	;retranche 1  A0
	move.w      A0,pointeur                                                     ;sauvegarde la nouvelle valeur de pointeur
	move.w      #3,A5
	jmp         deplpoin                                                        ;goto deplpoin pour actualiser le pointeur

                                                                                ;sous programme si la touche droite est enfonce
droite:
	move.l      #0,A0                                                           ;vide A0
	move.w      pointeur,D0                                                     ;la variable pointeur va dans A0
	cmp.w       #%110,D0                                                        ;vrifie si A0=6
	beq         getkey                                                      	;goto loop
	add         #%1,D0                                                      	;ajoute 1  A0
	move.w      D0,pointeur                                                     ;sauvegarde la nouvelle valeur du pointeur
	move.w      #3,A5
	jmp         deplpoin                                                        ;goto deplpoin pour actualiser le pointeur

rempl1:
	move.w      #6,d2
\init1:
	move.w      #6,d3
\init2:
	move.w      d2,d0
	move.w      d3,d1
	bsr         tpui
	move.w      #0,(a6)
	move.w      d2,d0
	move.w      #0,d1
	bsr         tpui
	move.w      #6,(a6)
	dbra        d3,\init2
	dbra        d2,\init1
	rts

lg:                                                                             ;procedure pour aller soit a loop soit a getkey
	cmp         #2,A5
	beq         getkey
	cmp         #1,iavar
	beq         iajoueur
	cmp         #2,iavar
	beq         linkjoueur
	jmp         loop

iajoueur:
	cmp         #0,qui
	beq         ia
	jmp         loop

linkjoueur:
	move.w      qui,A6
	move.w      linkini,A4
	cmp         A4,A6
	beq         loop
;	jmp         link_receive
	

loop:
	move.l      #3,timeg                                                        ;nombre de dixaine de seconde pour le temps
	move.l      #1,timed                                                        ;nombre de seconde+1
	move.l      #0,A5
	bsr         afftime                                                         ;va afficher 30 pour le temps restant
	move.w      #0,D1
getkey:
;	move.w      #0,A5
	add.w       #1,D1
	move.l      #1,A5
	cmp         #4000,D1                                                        ;mettre 1000000
	beq         afftime                                                         ;si une seconde est passe : afficher le nouveau temps
	jsr         genlib::read_joypad
	btst.l      #ka_key,d0
	beq         verif
	btst.l      #right_key,d0
	beq         droite
	btst.l      #left_key,d0
	beq         gauche
	btst.l      #kb_key,d0
	beq         pause
	btst.l      #exit_key,d0
	beq         e_et_c                                                      	;va au label e_et_c : sauvegarde la partie, puis va  _main
;	move.l      #1,a5
	jmp         getkey

e_et_c:
	bsr         esvg
	jmp         _main

touchefin:
	bsr         rempl1
	bsr         esvg
	move.w      #0,-(A7)
	jsr         doorsos::FontSetSys
	lea         2(A7),A7
	pea         mail(PC)
	move.w      #80,-(A7)
	move.w      #33,-(A7)
	jsr         doorsos::DrawStrXY
	lea         8(A7),A7
	pea         url(PC)
	move.w      #90,-(A7)
	move.w      #23,-(A7)
	jsr         doorsos::DrawStrXY	
	lea         8(A7),A7
	pea         entreeq(PC)
	move.w      #50,-(A7)
	move.w      #14,-(A7)
	jsr         doorsos::DrawStrXY
	lea         8(A7),A7
	pea         entreeq1(PC)
	move.w      #60,-(A7)
	move.w      #46,-(A7)
	jsr         doorsos::DrawStrXY
	lea         10(A7),A7
	move.w      #1,svg
	jsr         genlib::wait_no_key
	jsr         genlib::wait_a_key
	jmp         _main
            	
pause:
	jsr         graphlib::clr_scr                                               ;efface l'cran
	move.w      #%10,-(A7)
	jsr         doorsos::FontSetSys
	lea         2(A7),A7
	move.w      #%100,-(A7)
	pea         pause1(PC)
	move.w      #45,-(A7)
	move.w      #55,-(A7)
	jsr         doorsos::DrawStrXY
	lea         10(A7),A7
	jsr         genlib::wait_no_key
	jsr         genlib::wait_a_key
	jmp         nveauecran
nveauecran:
	cmp         #0,svg
	bne         nouveau
	bsr         rsvg
	move.w      #2,A5
	bsr         affdecran
	bsr         afftime
	jmp         affecran

rsvg:                                                                           ;cherche des info dans le fichier p4svg
	clr.l       D0
	move.l      #p4svg,A0
	move.w      #1,D1
	jsr         filelib::search
	tst.w       d0
	beq         creefich
	move.w      #0,svg
	lea         pui,a1
	move.w      #115,d0
	move.w      #1,D1
	jsr         filelib::readfile
	cmp         #115,d0
	bne         erreur
	rts


erreur:
	rts
creefich:
	move.w      #1,svg
	move.l      #p4svg,A0
	move.w      #doorsos::MainHandle,D0
	jsr         filelib::createfile
	tst.w       D2
	bne         erreur
	move.w      #120,d0
	jsr         filelib::resizefile
	cmp         #120,d0
	bne         erreur
	rts

esvg:
	move.l      #p4svg,A0
	move.w      #1,D1
	jsr         filelib::search
	lea         pui,a1
	move.w      #115,d0
	move.w      #1,d1
	jsr         filelib::writefile
	cmp         #115,d0
	bne         erreur
	rts



                                                                                ;programme
_main:                                                                          ;dbut du programme
	move.l      a7,svgpile
	bsr         rsvg

;	jsr         genlib::init
	move.w      #$700,d0
	trap        #1

	move.w      #0,qui                                                      	;met 1 dans la variable qui
	move.w      #3,pointeur                                                     ;met 3 dans la variable pointeur

	move.w      #0,choix
	jsr         genlib::set_LCD_MEM
	jsr         graphlib::clr_scr
	move.w      #%10,-(A7)
	jsr         doorsos::FontSetSys
	lea         2(A7),A7
	move.w      #%100,-(A7)
	pea         titre1(PC)
	move.w      #3,-(A7)
	move.w      #33,-(A7)
	jsr         doorsos::DrawStrXY
	lea         8(A7),A7
	pea         titre2(PC)
	move.w      #20,-(A7)
	move.w      #27,-(A7)
	jsr         doorsos::DrawStrXY
	lea         8(A7),A7
	move.w      #1,-(A7)
	jsr         doorsos::FontSetSys
	lea         2(A7),A7
	pea         version(PC)
	move.w      #37,-(A7)
	move.w      #40,-(A7)                                                       ;mettre 40 si version x.xx ou 42 si version x.x
	jsr         doorsos::DrawStrXY
	lea         8(A7),A7
	move.w      #%0,-(A7)
	jsr         doorsos::FontSetSys
	lea         2(A7),A7
	pea         mail(PC)
	move.w      #88,-(A7)
	move.w      #33,-(A7)
	jsr         doorsos::DrawStrXY
	lea         8(A7),A7
	pea         url(PC)
	move.w      #95,-(A7)
	move.w      #23,-(A7)
	jsr         doorsos::DrawStrXY	
	lea         10(A7),A7                                                       ;affiche l'cran d'accueil

choixmain:
	bsr         affchoix
	jsr         genlib::wait_a_key
	jsr         genlib::read_joypad                                          	;valeur de la touche dans D0
	btst.l      #right_key,d0
;	beq         choixgauche
	beq         choixmode
	btst.l      #left_key,d0
	beq         choixmode
;	beq         choixdroite
	btst.l      #up_key,d0
	beq         choixchg
	btst.l      #down_key,d0
	beq         choixchg
	btst.l      #ka_key,d0
	beq         choixok
	btst.l      #exit_key,d0
	beq         quit
	jmp         choixmain                                                       ;cran d'accueil

nouveau:
;	bsr         linkdeb
	move.w      #0,svg
	bsr         affdecran
	move.w      #0,A5
	move.w      #0,A0
	bsr         rempl1
	bsr         esvg
	jmp         affecran

quit:
	bsr         esvg
;	jsr         genlib::quit
;	bsr         graphlib::clr_scr
	jsr         genlib::wait_no_key
	move.w      #0,d0
	trap        #1

	move.l      svgpile,a7
	rts

_exit:
	move.w      #0,d0
	trap        #1
	move.l      svgpile,a7
	rts

 ;donnes


pui             ds.w	49                                                      ;ATTENTION
iavar           dc.w	0                                                       ;ne pas changer l'ordre des 7 premieres variables
qui             dc.w	0                                                       ;si erreur avec la sauvegarde
quisvg      	dc.w	0
svg             dc.w	0
timeg           dc.l	0
timed           dc.l	0

puir            ds.w	49

svgpile         dc.l	0
flecheg         dc.b	17,0
fleched         dc.b	18,0
flecheh         dc.b	19,0
flecheb         dc.b	20,0
tpoids      	ds.w	14
choix           dc.w	1
pointeur        dc.w	0                                                       ;variable du pointeur
linkini         dc.w	0
linkqui         dc.w	0                                                       ;=1 si joueur=maitre et =0 si joueur=esclave
memvainc0       dc.w	0
memvainc1       dc.w	0
p4svg           dc.b	"p4svg",0







	end                                                                         ;fin du programme